#ifndef __EZMANAGERLIB_H
#define __EZMANAGERLIB_H

//"ezManager library(VB DLL) version 2.0B 2012/11/12 by SOLLAE systems Co., LTD."

#include <winsock2.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

typedef BYTE			_u8;
typedef WORD			_u16;
typedef DWORD			_u32;

#define PASSWD_SIZE		10
#define MAX_COM_PORT	48
#define MAX_DI			8
#define MAX_DO			8
#define MAX_TCP_SESSION 48

#define IO_SCRIPT_LEN		32
#define IO_COMMENT_LEN		16
#define UART_COMMENT_LEN	32

#define EZTCP_ERR					-1
#define	EZTCP_ERR_PWD				-100
#define	EZTCP_ERR_RES				-200
#define EZTCP_ERR_LOCAL_IP			-300
#define EZTCP_ERR_IO_SCRIPT			-400
#define EZTCP_ERR_IO_ADDR			-500
#define EZTCP_ERR_LOCAL_PORT_100	-600
#define EZTCP_ERR_LOCAL_PORT_101	-601
#define EZTCP_ERR_LOCAL_PORT_102	-602
#define EZTCP_ERR_LOCAL_PORT_103	-603
#define EZTCP_ERR_LOCAL_PORT_104	-604
#define EZTCP_ERR_LOCAL_PORT_105	-605
#define EZTCP_ERR_PRODUCT_MISMATCH	-700 /* product ID mismatch */
#define EZTCP_ERR_UNKNOWN			-800 /* Unknown Error */
#define EZTCP_ERR_NO_INFO			-900
#define EZTCP_ERR_WRONG_WAIT_TIME	-901 /* Invalid wait time value */
#define EZTCP_ERR_NO_NETWORK		-903
#define EZTCP_ERR_FLASH_NOSPACE		-904

#define MUX_TYPE_T2S  0 /* Tcp to Serial */
#define MUX_TYPE_ATC  1 /* AT Command */
#define MUX_TYPE_COD  2 /* Connect On Demand */
#define MUX_TYPE_U2S  3 /* UDP 2 Serial */
#define MUX_TYPE_MOD  4 /* Modbus Client */

#define OLD_PID_CIE_H10		0x10	/* 16 : CIE-H10/M10/H14 */
#define OLD_PID_CSE_H20		0x11	/* 17 : CSE-H20/H21 */
#define OLD_PID_CSE_M32		0x12	/* 18 : CSE-M32 */
#define OLD_PID_CSE_M31		0x13	/* 19 : CSE-M32 SPI */
#define OLD_PID_CSE_M73		0x14	/* 20 : CSE-M73 2 ports board type, RS-232 / 422 / 485 */
#define OLD_PID_CSW_M80		0x15	/* 21 : CSW-H80/M80 */

#define PID_CIE_H10		0x20	/* 32 : CIE-H10 */
#define PID_CIE_M10		0x21	/* 33 : CIE-M10 */
#define PID_CIE_H14		0x22	/* 34 : CIE-H14 */
#define PID_CSE_M32		0x23	/* 35 : CSE-M32 */
#define PID_CSE_H20		0x24	/* 36 : CSE-H20 */
#define PID_CSE_H21		0x25	/* 37 : CSE-H21 */
#define PID_CSE_M73		0x26	/* 38 : CSE-M73 */
#define PID_CSW_H80		0x27	/* 39 : CSW-H80 */
#define PID_CSW_M80		0x28	/* 40 : CSW-M80 */
#define PID_CSE_H25		0x29	/* 41 : CSE-H25 */
#define PID_CSE_M51		0x2a	/* 42 : CSE-M51 */
#define PID_CSE_M53		0x2b	/* 43 : CSE-M53 */
#define PID_CSE_H53		0x2c	/* 44 : CSE-H53 */
#define PID_CSW_M83		0x2d	/* 45 : CSW-M83 */
#define PID_CSW_M85		0x2e	/* 46 : CSW-M85 */
#define PID_CSE_H55		0x2f	/* 47 : CSE-H55 */
#define PID_CSC_HR2		0x30	/* 48 : CSC-HR2 */
#define PID_CSC_HR3		0x32	/* 50 : CSC-HR3 */
#define PID_CUE_H40		0x33	/* 51 : CUE-H40 */
#define PID_CIE_H12		0x34	/* 52 : CIE-H12 */
#define PID_CSW_H85		0x35	/* 53 : CSW-H85 */
#define PID_CSE_T32		0x36	/* 54 : CSE-T32 */
#define PID_CSE_M53A	0x37	/* 55 : CSE-M53A */
#define PID_CSE_T16		0x39	/* 57 : CSE-T16 */
#define PID_CSE_T48		0x3a	/* 58 : CSE-T48 */
#define PID_CSE_H53A	0x3b	/* 59 : CSE-H53A */
#define PID_CSW_M84		0x3c	/* 60 : CSE-M84 */
#define PID_CSE_M53N	0x3d	/* 61 : CSE-M53N */
#define PID_CSE_H53N	0x3e	/* 62 : CSE-H53N */
#define PID_CSE_H55N	0x3f	/* 63 : CSE-H55N */



#define MK_IP(__b1,__b2,__b3,__b4) \
( ((unsigned long)(__b4) << 24) | ((unsigned long)(__b3) << 16) | \
  ((unsigned long)(__b2) <<  8) | ((unsigned long)(__b1)) )

struct vb_net_env
{
	_u8		mac_addr		[6];
	_u8		secure			[6];
	_u32	major;
	_u32	minor;
	_u32	rev;
	_u32	local_ip;
	_u32	net_mask;
	_u32	gate_ip;
	_u8		pppoe_id		[32];
	_u8     pppoe_pwd		[16];
	_u32	socket_ip;
	_u32	dns_ip;
	_u16	product_id_old;
	_u16	product_id_new;
	_u8		ddns_id			[32];
	_u8		ddns_pwd		[16];
	_u8		ddns_host_name	[64];
	_u8		ssh_id			[16];
	_u8		ssh_pwd			[16];
};

struct vb_uart_dev_env
{
	_u32	max_stype;
	_u32	stype;
	_u32	databit;
	_u32	stopbit;

	_u32	parity;
	_u32	flowctrl;
	_u32	telcom;
	_u32	parity2;

	_u32	ttl;
	_u32	tx_delay;
	_u32	dtrdsr;	

	_u32	max_baud;
	_u32	sio_baud;
};

struct vb_uart_var_env
{
	_u32	local_ip;
	_u32	peer_ip;
	_u32	local_port;
	_u32	peer_port;
	_u32	mux_type;
	_u32	no_delay;
	_u32	cod_listen;
	_u32	secure;
	_u32	water_mark;
	_u32	time_mark;
	_u32	timeout;
};

//===============================================
struct vb_uart_del_env
{
	_u8		del_char[4];
	_u32	del_len;
	_u32	max_type;
	_u32	del_type;
};
//===============================================

struct vb_uart_env
{
	struct vb_uart_dev_env  vb_uart_dev_env;
	struct vb_uart_var_env	vb_uart_var_env;
	struct vb_uart_del_env	vb_uart_del_env;
	_u8						host_name	[64];
	_u8						comment		[UART_COMMENT_LEN];
	_u32					use_flag;
};

struct vb_opt_env
{
	_u32	ezcfg_lock;
	_u32	rcfg;
	_u32	arp;
	_u32	dhcp;
	_u32	pppoe;
	_u32	auto_ns;
	_u32	ip6;
	_u32	ip6_eui;
	_u32	ip6_gua;

	_u32	debug;
	_u32	telnet;
	_u32	ssl;
	_u32	ssh;
	_u32	http;
	_u32	ddns;
	_u32	t2smc;
	_u32	secure;
	_u32	mac_id;
	_u32	ps;
	_u32	pd;
};

struct vb_ip6_env
{
	_u32	ip6_gua			[16];
	_u32	ip6_gua_prefix;
	_u32	ip6_gateway		[16];
	_u32	ip6_dns			[16];
	_u32	ip6_uart_peer	[MAX_COM_PORT][16];
};

struct vb_etc_env
{
	_u8		allow_mac		[6];
	_u16	pad0;
	_u32	allow_ip;
	_u32	allow_subnet;
	_u8		comment			[64];
	_u8		pwd_old			[PASSWD_SIZE];
	_u8		pwd				[PASSWD_SIZE];
	_u32	allow_ip6		[16];
	_u32	allow_ip6_prefix;
};

struct vb_io_var_env
{
	_u32	modbus;
	_u32	macro;
	_u32	master;
	_u32	active;
	_u32	notify;
	_u32	conns;
	_u32	emacro;
	_u32	query;
	_u32	ctrl;
	_u32	peer_ip;
	_u32	peer_port;
	_u32	slave_id;
	_u32	input_addr;
	_u32	output_addr;
	_u32	init_output;
	_u32	poll_interval;
	_u32	input_valid_time[8];
	_u32	output_delay	[8];
};

struct vb_io_env
{
	_u8						di_num;
	_u8						do_num;
	_u16					html_size;
	_u8						script0		[IO_SCRIPT_LEN]; 
	_u8						script1		[IO_SCRIPT_LEN]; 
	_u8						script2		[IO_SCRIPT_LEN]; 
	_u8						script3		[IO_SCRIPT_LEN]; 
	_u8						script4		[IO_SCRIPT_LEN]; 
	_u8						script5		[IO_SCRIPT_LEN]; 
	_u8						script6		[IO_SCRIPT_LEN]; 
	_u8						script7		[IO_SCRIPT_LEN]; 

	_u8						di_comment0	[IO_COMMENT_LEN];
	_u8						di_comment1	[IO_COMMENT_LEN];
	_u8						di_comment2	[IO_COMMENT_LEN];
	_u8						di_comment3	[IO_COMMENT_LEN];
	_u8						di_comment4	[IO_COMMENT_LEN];
	_u8						di_comment5	[IO_COMMENT_LEN];
	_u8						di_comment6	[IO_COMMENT_LEN];
	_u8						di_comment7	[IO_COMMENT_LEN];

	_u8						do_comment0	[IO_COMMENT_LEN];
	_u8						do_comment1	[IO_COMMENT_LEN];
	_u8						do_comment2	[IO_COMMENT_LEN];
	_u8						do_comment3	[IO_COMMENT_LEN];
	_u8						do_comment4	[IO_COMMENT_LEN];
	_u8						do_comment5	[IO_COMMENT_LEN];
	_u8						do_comment6	[IO_COMMENT_LEN];
	_u8						do_comment7	[IO_COMMENT_LEN];

	_u8						host_name	[64];

	struct vb_io_var_env	vb_io_var_env;
	_u32					use_flag;						
};

struct vb_ip_trap_env
{
	_u32	level;
	_u32	peer_ip;
	_u32	peer_port;
	_u32	interval;
};

struct vb_port_map_env
{
	_u32	http_port;
	_u32	reserved1;
	_u32	reserved2;
	_u32	reserved3;
	_u32	reserved4;
};

struct vb_wlan_opt
{
	_u32 	cctype;
	_u32 	channel;
	_u32 	wep;
	_u32 	wep_id;
	_u32	bg_scan;
	_u32 	auth;
	_u32 	wpa;
	_u32 	cipher;
	_u32	antenna;
	_u32	phy;
	_u32	short_preamble;
	_u32	short_slot;
	_u32	cts_protection;
};

struct vb_wlan_var
{
	_u8		ssid			[32];

	_u8		key40_key0		[5];
	_u8		key40_key1		[5];
	_u8		key40_key2		[5];
	_u8		key40_key3		[5];

	_u8		key104_key0		[13];
	_u8		key104_key1		[13];
	_u8		key104_key2		[13];
	_u8		key104_key3		[13];

	_u8		wpa_passphrase	[64];
	_u8		wpa_psk			[32];
	_u8		power_table		[16];
	_u32	key_flag;
	_u8		eap_id			[32];
	_u8		eap_pwd			[16];
};

struct vb_wlan_env
{
	struct vb_wlan_opt	vb_wlan_opt_env;
	struct vb_wlan_var	vb_wlan_var_env;
	_u32				use_flag;
};

struct vb_tcp_status_env
{
	_u32	stat;
	_u32	winq_out;
	_u8		session_name[8];
	_u32	local_ip;
	_u32	peer_ip;
	_u16	local_port;
	_u16	peer_port;
};

struct vb_redundancy_var_env
{
	_u32	peer_ip1;
	_u32	peer_ip2;
	_u32	peer_port1;
	_u32	peer_port2;
	_u32	timeout1;
	_u32	timeout2;
	_u32	threshold1;
	_u32	threshold2;
	_u32 	check_port;		
};

struct vb_csc_hr2_env
{
	struct vb_uart_dev_env		 	vb_uart_dev_env;
	_u32							mux_type;
	_u8								csc_hr2_id			[16];
	_u8								server_host_name1	[64];
	_u8								server_host_name2	[64];
	struct vb_redundancy_var_env 	vb_redundancy_var_env;
};

struct vb_lib_env
{
	struct vb_net_env		vb_net_env;
	struct vb_ip6_env		vb_ip6_env;
	struct vb_uart_env		vb_uart_env[MAX_COM_PORT];
	struct vb_opt_env		vb_opt_env;
	struct vb_etc_env		vb_etc_env;
	struct vb_io_env		vb_io_env;	
	struct vb_ip_trap_env	vb_ip_trap_env;
	struct vb_port_map_env	vb_port_map_env;
	struct vb_wlan_env		vb_wlan_env;
	struct vb_csc_hr2_env	vb_csc_hr2_env;
};

//=======================================================================================================
void __stdcall Exit_Library(void);
// Main functions.
/* mode : 0 - Local, 1 - Remote */
int __stdcall	EzManager_Search	(	int					mode, 
										_u32				ip, 
										struct vb_lib_env	*vb_lib_env, 
										int					*nResultCount, 
										int					*nErrNum,
										int					port	= 0,
										_u32				bind_ip = 0);

int __stdcall	EzManager_Read		(	int					mode,
										_u8					*mac_addr,
										_u32				ip,
										struct vb_lib_env	*vb_lib_env,
										int					*nErrNum,
										int					port	= 0,
										_u32				bind_ip = 0);

int __stdcall	EzManager_Write		(	int					mode, 
										struct vb_lib_env	*vb_lib_env, 
										_u8					*cur_pwd, 
										int					*nErrNum,
										int					port	= 0,
										_u32				bind_ip = 0); 

int __stdcall	EzManager_Status	(	int							mode, 
										struct vb_lib_env			*vb_lib_env, 
										_u8							*stat_buf, 
										int							stat_buf_len, 
										struct vb_tcp_status_env	*vb_tcp_status_env,
										int							*tcp_session_count,
										int							*nErrNum,
										int							port	= 0,
										_u32						bind_ip = 0);

int __stdcall	EzManager_ChangePwd	(	int					mode, 
										struct vb_lib_env	*vb_lib_env, 
										_u8					*cur_pwd, 
										_u8					*new_pwd, 
										int					*nErrNum,
										int					port	= 0,
										_u32				bind_ip = 0);

int __stdcall	EzManager_CloseTCP	(	int							mode,
										struct vb_lib_env			*vb_lib_env,
										struct vb_tcp_status_env	*vb_tcp_status_env,
										_u8							*cur_pwd,
										int							*nErrNum,
										int							port	= 0,
										_u32						bind_ip = 0);

int __stdcall	EzManager_RdbOnOff	(	int		mode,
										_u8		*mac_addr,
										_u32	eztcp_ip,
										BOOL	onoff,
										_u32	rcvd_ip,
										int		*nErrNum,
										int		port	= 0,
										_u32	bind_ip = 0);

int __stdcall	EzManager_ReBoot	(	int		mode,
										_u8		*mac_addr,
										_u32	eztcp_ip,
										int		*nErrNum,
										int		port	= 0,
										_u32	bind_ip = 0);

//----------------------------------------------------------------------
char* __stdcall		GetLibVer		();
char* __stdcall		GetProductName	(int product_id);
//=======================================================================================================

#endif
